/*
 * Created on 2019-08-18 ( Time 17:15:11 )
 * Generated by Telosys Tools Generator ( version 3.0.0 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.diaspora.star.motors.sarl.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;
import java.util.List;

import javax.persistence.*;

/**
 * Persistent class for entity stored in table "fiche_preparation_devis"
 *
 * @author Telosys Tools Generator
 *
 */

@Entity
@Table(name="fiche_preparation_devis" )
public class FichePreparationDevis implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_verificateur")
    private Boolean    isValidedByVerificateur ;

	/*
	 * 
	 */
    @Column(name="is_valided_by_valideur")
    private Boolean    isValidedByValideur ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_validation_verificateur")
    private Date       dateValidationVerificateur ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_validation_valideur")
    private Date       dateValidationValideur ;

	// "ordreReparationId" (column "ordre_reparation_id") is not defined by itself because used as FK in a link 
	// "etatId" (column "etat_id") is not defined by itself because used as FK in a link 
	// "userVerificateurId" (column "user_verificateur_id") is not defined by itself because used as FK in a link 
	// "userValideurId" (column "user_valideur_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="ordre_reparation_id", referencedColumnName="id")
    private OrdreReparation ordreReparation;
    @ManyToOne
    @JoinColumn(name="user_verificateur_id", referencedColumnName="id")
    private User userVerificateur       ;
    @ManyToOne
    @JoinColumn(name="user_valideur_id", referencedColumnName="id")
    private User userValideur        ;
    @ManyToOne
    @JoinColumn(name="etat_id", referencedColumnName="id")
    private Etat etat        ;

    //----------------------------------------------------------------------
    // CONSTRUCTOR(S)
    //----------------------------------------------------------------------
    public FichePreparationDevis() {
		super();
    }
    
    //----------------------------------------------------------------------
    // GETTER & SETTER FOR THE KEY FIELD
    //----------------------------------------------------------------------
    public void setId( Integer id ) {
        this.id = id ;
    }
    public Integer getId() {
        return this.id;
    }

    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR FIELDS
    //----------------------------------------------------------------------
    //--- DATABASE MAPPING : is_deleted ( BIT ) 
    public void setIsDeleted( Boolean isDeleted ) {
        this.isDeleted = isDeleted;
    }
    public Boolean getIsDeleted() {
        return this.isDeleted;
    }

    //--- DATABASE MAPPING : created_at ( DATETIME ) 
    public void setCreatedAt( Date createdAt ) {
        this.createdAt = createdAt;
    }
    public Date getCreatedAt() {
        return this.createdAt;
    }

    //--- DATABASE MAPPING : updated_at ( DATETIME ) 
    public void setUpdatedAt( Date updatedAt ) {
        this.updatedAt = updatedAt;
    }
    public Date getUpdatedAt() {
        return this.updatedAt;
    }

    //--- DATABASE MAPPING : deleted_at ( DATETIME ) 
    public void setDeletedAt( Date deletedAt ) {
        this.deletedAt = deletedAt;
    }
    public Date getDeletedAt() {
        return this.deletedAt;
    }

    //--- DATABASE MAPPING : created_by ( INT ) 
    public void setCreatedBy( Integer createdBy ) {
        this.createdBy = createdBy;
    }
    public Integer getCreatedBy() {
        return this.createdBy;
    }

    //--- DATABASE MAPPING : updated_by ( INT ) 
    public void setUpdatedBy( Integer updatedBy ) {
        this.updatedBy = updatedBy;
    }
    public Integer getUpdatedBy() {
        return this.updatedBy;
    }

    //--- DATABASE MAPPING : deleted_by ( INT ) 
    public void setDeletedBy( Integer deletedBy ) {
        this.deletedBy = deletedBy;
    }
    public Integer getDeletedBy() {
        return this.deletedBy;
    }

    //--- DATABASE MAPPING : is_valided_by_verificateur ( BIT ) 
    public void setIsValidedByVerificateur( Boolean isValidedByVerificateur ) {
        this.isValidedByVerificateur = isValidedByVerificateur;
    }
    public Boolean getIsValidedByVerificateur() {
        return this.isValidedByVerificateur;
    }

    //--- DATABASE MAPPING : is_valided_by_valideur ( BIT ) 
    public void setIsValidedByValideur( Boolean isValidedByValideur ) {
        this.isValidedByValideur = isValidedByValideur;
    }
    public Boolean getIsValidedByValideur() {
        return this.isValidedByValideur;
    }

    //--- DATABASE MAPPING : date_validation_verificateur ( DATETIME ) 
    public void setDateValidationVerificateur( Date dateValidationVerificateur ) {
        this.dateValidationVerificateur = dateValidationVerificateur;
    }
    public Date getDateValidationVerificateur() {
        return this.dateValidationVerificateur;
    }

    //--- DATABASE MAPPING : date_validation_valideur ( DATETIME ) 
    public void setDateValidationValideur( Date dateValidationValideur ) {
        this.dateValidationValideur = dateValidationValideur;
    }
    public Date getDateValidationValideur() {
        return this.dateValidationValideur;
    }


    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR LINKS
    //----------------------------------------------------------------------

    public void setOrdreReparation( OrdreReparation ordreReparation ) {
        this.ordreReparation = ordreReparation;
    }
    public OrdreReparation getOrdreReparation() {
        return this.ordreReparation;
    }


    public void setUserVerificateur( User userVerificateur ) {
        this.userVerificateur = userVerificateur;
    }
    public User getUserVerificateur() {
        return this.userVerificateur;
    }


    public void setUserValideur( User userValideur ) {
        this.userValideur = userValideur;
    }
    public User getUserValideur() {
        return this.userValideur;
    }


    public void setEtat( Etat etat ) {
        this.etat = etat;
    }
    public Etat getEtat() {
        return this.etat;
    }


    //----------------------------------------------------------------------
    // toString METHOD
    //----------------------------------------------------------------------
    public String toString() { 
        StringBuffer sb = new StringBuffer(); 
        sb.append("["); 
        sb.append(id);
        sb.append("]:"); 
        sb.append(isDeleted);
        sb.append("|");
        sb.append(createdAt);
        sb.append("|");
        sb.append(updatedAt);
        sb.append("|");
        sb.append(deletedAt);
        sb.append("|");
        sb.append(createdBy);
        sb.append("|");
        sb.append(updatedBy);
        sb.append("|");
        sb.append(deletedBy);
        sb.append("|");
        sb.append(isValidedByVerificateur);
        sb.append("|");
        sb.append(isValidedByValideur);
        sb.append("|");
        sb.append(dateValidationVerificateur);
        sb.append("|");
        sb.append(dateValidationValideur);
        return sb.toString(); 
    } 

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
